--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
initMainBar = function()
    log("initMainBar()");
    
    local frameAlignment = DCVGlobal["AlignmentOptions"][ DCoordsVDB["MainBar"].alignmentIndex ];
    local textAlignment = DCVGlobal["AlignmentOptions"][ DCoordsVDB["MainBar"].fontAlignmentIndex ];
    local ox = DCoordsVDB["MainBar"].fontOffsetX;
    local oy = DCoordsVDB["MainBar"].fontOffsetY;
    local textJustification = DCVGlobal["JustificationOptions"][ DCoordsVDB["MainBar"].fontSelectedJustificationIndex ];
    log("initMainBar(): frameAlignment = " .. frameAlignment);
    log("initMainBar(): textAlignment = " .. textAlignment);
    log("initMainBar(): ox = " .. ox);
    log("initMainBar(): oy = " .. oy);
    --DCoordsVDB["MainBar"].x = 0;
    --DCoordsVDB["MainBar"].y = 0;
    
    -- Frame
	--DCVGlobal["DCMainBarFrameName"] = "DCoordsMainBar" .. tostring(math.random(99999999));
	DCVGlobal["DCMainBar"] = CreateFrame("frame","DCoordsMainBar",uip);
    DCVGlobal["DCMainBar"]:SetFrameStrata("HIGH");
    DCVGlobal["DCMainBar"]:EnableMouse(false);
	DCVGlobal["DCMainBar"]:SetResizable(true);
	DCVGlobal["DCMainBar"]:SetMovable(true);
    DCVGlobal["DCMainBar"]:SetWidth(500);
    DCVGlobal["DCMainBar"]:SetHeight(200);
    
    DCVGlobal["DCMainBar"]:ClearAllPoints(true);
    DCVGlobal["DCMainBar"]:SetPoint(frameAlignment,DCoordsVDB["MainBar"].x,DCoordsVDB["MainBar"].y);
    
    --DCVGlobal["DCMainBar"]:SetPoint("BOTTOMLEFT",DCoordsVDB["MainBar"].x,DCoordsVDB["MainBar"].y);
    
    -- Init bg texture
    DCVGlobal["DCMainBar"].texture = DCVGlobal["DCMainBar"]:CreateTexture (nil, "background");
    
    -- Frame text
    --DCVGlobal["DCMainBarText"] = DCVGlobal["DCMainBar"]:CreateFontString("DCMainBarText", "OVERLAY", "GameTooltipText");
    --function createLabel(name,frameContainer,text,size,r,g,b,a,justify,x,y)
    DCVGlobal["DCMainBarText"] = createLabel("DCMainBarText",DCVGlobal["DCMainBar"],"DLL",14,1,1,1,1,"LEFT",0,0);
    
    --local textAlignment = DCVGlobal["AlignmentOptions"][ DCoordsVDB["MainBar"].fontAlignmentIndex ];
    --DCVGlobal["DCMainBarText"]:SetPoint("BOTTOMLEFT",DCVGlobal["DCMainBar"],"BOTTOMLEFT",0,0);
    --DCVGlobal["DCMainBarText"]:SetPoint("LEFT",0,0);
    DCVGlobal["DCMainBarText"]:SetPoint(textJustification,ox,oy);
    DCVGlobal["DCMainBarText"]:SetJustifyH("LEFT");
    
    
    
	DCVGlobal["DCMainBarText"]:SetFont(getMainFrameFont(), DCoordsVDB["MainBar"].fontSize,"OUTLINE");
	DCVGlobal["DCMainBarText"]:SetShadowOffset(1, -1);
	DCVGlobal["DCMainBarText"]:SetTextColor(
        DCoordsVDB["MainBar"].fontR,
        DCoordsVDB["MainBar"].fontG,
        DCoordsVDB["MainBar"].fontB,
        DCoordsVDB["MainBar"].fontA
    );
	DCVGlobal["DCMainBarText"]:SetNonSpaceWrap(false);
	DCVGlobal["DCMainBarText"]:SetText("Darcey@AllForTheCode.co.uk");
	
    --DCVGlobal["DCMainBarText"]:SetJustifyH(        DCVGlobal["AlignmentTypes"][DCoordsVDB["MainBarTextSelectedAlignment"]]    );
    
    DCVGlobal["DCMainBar"]:Hide();
    DCVGlobal["DCMainBar"]:Show();
    
    
    
    -- On mouse up handler
    DCVGlobal["DCMainBar"]:SetScript("OnMouseUp", function(self,buttonIdentifier) mainBarMouseUpHandler(self,buttonIdentifier) end);
    
    
    -- Drag
    DCVGlobal["DCMainBar"]:RegisterForDrag("LeftButton");
	
	DCVGlobal["DCMainBar"]:SetScript("OnDragStart", function(self)
		if (IsShiftKeyDown()) then 
			toChat("DCoords: Drag started!"); 
			self:StartMoving();
		end 
	end);
	
	DCVGlobal["DCMainBar"]:SetScript("OnDragStop", function(self)        
        local selectedAlignment = DCVGlobal["AlignmentOptions"][ DCoordsVDB["MainBar"].alignmentIndex ];
        
        if (selectedAlignment == "TOPLEFT") then
            DCoordsVDB["MainBar"].x = self:GetLeft(); 
            DCoordsVDB["MainBar"].y = 0 - (GetScreenHeight() - self:GetTop());
        elseif (selectedAlignment == "LEFT") then
            DCoordsVDB["MainBar"].x = self:GetLeft(); 
            DCoordsVDB["MainBar"].y = (self:GetTop()-(self:GetHeight()/2)) - (GetScreenHeight()/2);
        elseif (selectedAlignment == "BOTTOMLEFT") then
            DCoordsVDB["MainBar"].x = self:GetLeft(); 
            DCoordsVDB["MainBar"].y = (self:GetTop() - self:GetHeight());
        elseif (selectedAlignment == "TOP") then
            DCoordsVDB["MainBar"].x = self:GetLeft() - (GetScreenWidth()/2) + (self:GetWidth()/2);
            DCoordsVDB["MainBar"].y = 0 - (GetScreenHeight() - self:GetTop());
        elseif (selectedAlignment == "CENTER") then
            DCoordsVDB["MainBar"].x = self:GetLeft() - (GetScreenWidth()/2) + (self:GetWidth()/2);
            DCoordsVDB["MainBar"].y = (self:GetTop()-(self:GetHeight()/2)) - (GetScreenHeight()/2);
        elseif (selectedAlignment == "BOTTOM") then
            DCoordsVDB["MainBar"].x = self:GetLeft() - (GetScreenWidth()/2) + (self:GetWidth()/2);
            DCoordsVDB["MainBar"].y = (self:GetTop() - self:GetHeight());
        elseif (selectedAlignment == "TOPRIGHT") then
            DCoordsVDB["MainBar"].x = 0 - (GetScreenWidth() - self:GetLeft()) + self:GetWidth();
            DCoordsVDB["MainBar"].y = 0 - (GetScreenHeight() - self:GetTop());
        elseif (selectedAlignment == "RIGHT") then
            DCoordsVDB["MainBar"].x = 0 - (GetScreenWidth() - self:GetLeft()) + self:GetWidth();
            DCoordsVDB["MainBar"].y = (self:GetTop()-(self:GetHeight()/2)) - (GetScreenHeight()/2);
        elseif (selectedAlignment == "BOTTOMRIGHT") then
            DCoordsVDB["MainBar"].x = 0 - (GetScreenWidth() - self:GetLeft()) + self:GetWidth();
            DCoordsVDB["MainBar"].y = (self:GetTop() - self:GetHeight());
        end
		--DCoordsVDB["MainBar"].y = GetScreenHeight() - (self:GetTop() - self:GetHeight());
        
        log(    "DCoords: Drag finished: x:" .. DCoordsVDB["MainBar"].x .. "   y:" .. DCoordsVDB["MainBar"].y  );
         
		
		self:StopMovingOrSizing()
        mainBarSetFrameAlignment();
        mainBarSetFont();
        
        toChat("DCoords: Drag complete!");
	end);
    

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarMouseUpHandler(self,buttonIdentifier)
    --log("mainBarMouseUpHandler(self,buttonIdentifier:"..buttonIdentifier..")");
	if (buttonIdentifier == "RightButton") then
		showOptions();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarSetVisibility()
    --log("mainBarSetVisibility(): " .. tostring(DCoordsVDB["MainBar"].visible) );

    if (DCoordsVDB["MainBar"].visible) then
		DCVGlobal["DCMainBar"]:Show();
	else
		DCVGlobal["DCMainBar"]:Hide();
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarSetBackground()
    --log("mainBarSetBackground()");

    if (DCoordsVDB["MainBar"].bgVisible) then
		if (DCoordsVDB["MainBar"].bgSelectedIndex == 1) then
        
			DCVGlobal["DCMainBar"].texture:SetColorTexture(0,0,0,0);
            
            local tileSize = 10;
            local edgeSize = 10;
            local insets = 3;
            
			DCVGlobal["DCMainBar"]:SetBackdrop({
				bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
				edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
				tile = true, tileSize = tileSize, edgeSize = edgeSize,
				insets = { left = insets, right = insets, top = insets, bottom = insets }
			})
		else
			DCVGlobal["DCMainBar"]:SetBackdrop(nil); -- Hide/Remove classic frame
			DCVGlobal["DCMainBar"].texture = DCVGlobal["DCMainBar"]:CreateTexture (nil, "background");
			DCVGlobal["DCMainBar"].texture:SetColorTexture(
				DCoordsVDB["MainBar"].bgR,
				DCoordsVDB["MainBar"].bgG,
				DCoordsVDB["MainBar"].bgB,
				DCoordsVDB["MainBar"].bgA
			);
			DCVGlobal["DCMainBar"].texture:SetAllPoints(true);
		end
	else
		DCVGlobal["DCMainBar"].texture:SetColorTexture(0,0,0,0);
        DCVGlobal["DCMainBar"]:SetBackdrop(nil); -- Hide/Remove classic frame
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateBoxBgColor()
    --log("updateBoxBgColor()");
    DCVGlobal["DCMainBar"].texture:SetColorTexture(
			DCoordsVDB["MainBar"].bgR,
			DCoordsVDB["MainBar"].bgG,
			DCoordsVDB["MainBar"].bgB,
			DCoordsVDB["MainBar"].bgA
	);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- http://wowprogramming.com/docs/widgets/Frame
-- http://wowprogramming.com/docs/widgets/Region/SetPoint
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarSetFrameAlignment()
    log("mainBarSetFrameAlignment()");
    
    --[[--]]
    
    local selectedAlignment = DCVGlobal["AlignmentOptions"][ DCoordsVDB["MainBar"].alignmentIndex ];
    
    DCVGlobal["DCMainBar"]:ClearAllPoints(true);
    --DCVGlobal["DCMainBar"]:SetAllPoints();
    DCVGlobal["DCMainBar"]:SetPoint(selectedAlignment,DCoordsVDB["MainBar"].x,DCoordsVDB["MainBar"].y);
    
    --DCoordsVDB["MainBar"].x = 0;
    --DCoordsVDB["MainBar"].y = 0;
    log("selectedAlignment:" .. selectedAlignment .. "   x:" .. DCoordsVDB["MainBar"].x .. "   y:" .. DCoordsVDB["MainBar"].y );    
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function mainBarSetFont()
    log("mainBarSetFont()");
    
    DCVGlobal["DCMainBarText"]:SetTextColor(
        DCoordsVDB["MainBar"].fontR,
        DCoordsVDB["MainBar"].fontG,
        DCoordsVDB["MainBar"].fontB,
        DCoordsVDB["MainBar"].fontA
    );
    
    
    DCVGlobal["DCMainBarText"]:SetFont(getMainFrameFont(), DCoordsVDB["MainBar"].fontSize,"OUTLINE");
    
    local textAlignment = DCVGlobal["AlignmentOptions"][ DCoordsVDB["MainBar"].fontAlignmentIndex ];
    local textJustification = DCVGlobal["JustificationOptions"][ DCoordsVDB["MainBar"].fontSelectedJustificationIndex ];
    local ox = DCoordsVDB["MainBar"].fontOffsetX;
    local oy = DCoordsVDB["MainBar"].fontOffsetY;
    log("mainBarSetFont(): textAlignment = " .. textAlignment);
    log("mainBarSetFont(): textJustification = " .. textJustification);
    
    DCVGlobal["DCMainBarText"]:ClearAllPoints();
    DCVGlobal["DCMainBarText"]:SetPoint(textJustification,ox,oy);
    
    DCVGlobal["DCMainBarText"]:SetJustifyH(textJustification);
    
    --DCVGlobal["DCMainBarText"]:SetPoint("LEFT", WorldFrame, "LEFT", 0,0);
    --DCVGlobal["DCMainBarText"]:SetPoint(textAlignment,DCoordsVDB["MainBar"].fontOffsetX,DCoordsVDB["MainBar"].fontOffsetY);
    
    
    --[[
    --DCVGlobal["DCMainBarText"]:SetJustifyH("LEFT");
    --]]
    
    DCVGlobal["DCMainBarText"]:SetText("Darcey@AllForTheCode.co.uk");   
    
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #