--[[
	Author: Darcey@AllForTheCode.co.uk
--]]


local frame;

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupPageMap()
	DCVGlobal["DCOptions"].Map = CreateFrame("FRAME", "DCoordsOptionsMainBar");
	frame = DCVGlobal["DCOptions"].Map; 
	frame.name = "World map";
	frame.parent = DCVGlobal["DCOptions"].Main.name;
	InterfaceOptions_AddCategory(frame);
	
	-- Add background to options to enhance readability
	frame:SetBackdrop({
		bgFile = "Interface/DialogFrame/UI-DialogBox-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 10, edgeSize = 10,
		insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	
	-- Titles
	AddDCoordsOptionsTitles(frame,"World map");
	
	
	
	setupWorldMapLeft();
	setupWorldMapRight();
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupWorldMapLeft()

	-- Vars
	local msg = "";
	local px = 10;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	
	--createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	--createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	--createButton(name,frameContainer,label,width,x,y,clickHandler)
	--createSlider(name,frameContainer,min,max,step,default,width,decimalPrecision,x,y,changeHandler)
	--createLabel(name,frameContainer,text,size,justify,x,y)
	
	
	
	
	--DCoordsVDB["MainBar"].visible
	local function cbWorldMapVisibleClickHandler(ticked)
		DCoordsVDB["WorldMap"].visible = ticked;
		worldMapSetVisibility();
	end
	createCheckbox("cbWorldMapVisible",frame,"World map coordinates visible",DCoordsVDB["WorldMap"].visible,px,py,cbWorldMapVisibleClickHandler);
	py = py - inc;
	
	
	
	
	
	--DCoordsVDB["WorldMap"].fontSelectedIndex
	local function worldMapFontChangeHandler(selectedIndex)
		DCoordsVDB["WorldMap"].fontSelectedIndex = selectedIndex;
		worldMapSetFont();
	end
	local fontLabels = {}
	for i = 1, 15, 1 do
		fontLabels[i] = "World map coordinates Font no' " .. tostring(i);
	end
	createDropDown("worldMapFontChangeHandler",frame,dropDownWidth,fontLabels,DCoordsVDB["WorldMap"].fontSelectedIndex,px,py,worldMapFontChangeHandler)
	py = py - 35;
	
	
	
	
			
	--DCoordsVDB["WorldMap"].fontSize
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontSizeChangeHandler(v)
		DCoordsVDB["WorldMap"].fontSize = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontSize",frame,5,50,0.1,"World map font size",DCoordsVDB["WorldMap"].fontSize,sliderWidth,1,px,py,worldMapFontSizeChangeHandler)
	py = py - 60;
	

	
	
	
	
	
	--DCoordsVDB["WorldMap"].fontAlignmentIndex
	local function worldMapAlignmentIndexChangeHandler(selectedIndex)
		DCoordsVDB["WorldMap"].fontAlignmentIndex = selectedIndex;
		worldMapSetPosition();
	end
	local worldMapAlignmentLabels = {
		"Align text to the TOP",
		"Align text to the BOTTOM"
	};
	createDropDown("worldMapAlignmentIndex",frame,dropDownWidth,worldMapAlignmentLabels,DCoordsVDB["WorldMap"].fontAlignmentIndex,px,py,worldMapAlignmentIndexChangeHandler)
	py = py - 34;
	
	
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "TOP ALIGNED: " .. "Best to set offset Y to values 0 to -50." .. "\n\n";
	local info11 = createLabel("DCWorldMapText1",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 20;
	
	
	--createLabel((name,frameContainer,text,size,r,g,b,a,justify,x,y)
	msg = "";
	msg = msg .. "BOTTOM ALIGNED: " .. "Best to set offset Y to values 0 to +50." .. "\n\n";
	local info11 = createLabel("DCWorldMapText2",frame,msg,14,1,0.5,0.5,1,"LEFT",px,py);
	py = py - 25;
	
	
	
	
		
	--DCoordsVDB["WorldMap"].fontSize
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontOffsetYChangeHandler(v)
		DCoordsVDB["WorldMap"].fontOffsetY = v;
		worldMapSetPosition();
	end
	createSlider("worldMapFontOffsetYChangeHandler",frame,-50,50,0.1,"World map font offset Y",DCoordsVDB["WorldMap"].fontOffsetY,sliderWidth,1,px,py,worldMapFontOffsetYChangeHandler)
	py = py - 70;
	
	
	
	
	
	
	
	--DCoordsVDB["WorldMap"].fontR
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontRChangeHandler(v)
		DCoordsVDB["WorldMap"].fontR = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontR",frame,0,1,0.1,"World map font Red (RGB)",DCoordsVDB["WorldMap"].fontR,sliderWidth,1,px,py,worldMapFontRChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["WorldMap"].fontG
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontGChangeHandler(v)
		DCoordsVDB["WorldMap"].fontG = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontG",frame,0,1,0.1,"World map font Green (RGB)",DCoordsVDB["WorldMap"].fontG,sliderWidth,1,px,py,worldMapFontGChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["WorldMap"].fontB
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontBChangeHandler(v)
		DCoordsVDB["WorldMap"].fontB = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontB",frame,0,1,0.1,"World map font Blue (RGB)",DCoordsVDB["WorldMap"].fontB,sliderWidth,1,px,py,worldMapFontBChangeHandler)
	py = py - 40;
	
	
	--DCoordsVDB["WorldMap"].fontA
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapFontAChangeHandler(v)
		DCoordsVDB["WorldMap"].fontA = v;
		worldMapSetFont();
	end
	createSlider("WorldMapFontA",frame,0,1,0.1,"World map font Alpha",DCoordsVDB["WorldMap"].fontA,sliderWidth,1,px,py,worldMapFontAChangeHandler)
	py = py - 40;
	
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function setupWorldMapRight()

	-- Vars
	local msg = "";
	local px = 300;
	local py = -60;
	local inc = 25;
	local dropDownWidth = 250;
	local sliderWidth = 250;
	
	
	--DCoordsVDB["WorldMap"].decimalPrecision
	--function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
	local function worldMapDecimalPrecisionChangeHandler(v)
		DCoordsVDB["WorldMap"].decimalPrecision = v;
	end
	createSlider("sWorldMapDecimalPrecision",frame,0,3,1,"World map decimal precision",DCoordsVDB["WorldMap"].decimalPrecision,sliderWidth,0,px,py,worldMapDecimalPrecisionChangeHandler)
	py = py - 40;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #