﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function log(arg1)
    if (DCoordsDebug) then
        print(tostring(arg1))
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function toChat(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getSystemDefaultFont()
    return ("Fonts\\FRIZQT.TTF");
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getAddonDefaultFont()
	local font = lsm:Fetch("font","Font "..1,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMainFrameFont()
    --local f = 16;
	--log("Trying to find Font " .. DCoords_MainFrameFont);
	local font = lsm:Fetch("font","Font "..DCoordsVDB["MainBar"].fontSelectedIndex,true);
    --log(fontFiles[f]);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMainFrameFontName()
    return "Font " .. tostring(DCoords_MainFrameFont);
	--return fontNames[DCoords_MainFrameFont]
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getFontAtIndex(index)
	local font = lsm:Fetch("font","Font "..index,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMapFrameFont()
	local font = lsm:Fetch("font","Font "..DCoordsVDB["WorldMap"].fontSelectedIndex,true);
	return font;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function getMapFrameFontName()
	return fontFiles[DCoords_MapFrameFont]
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function invertBoolean(bool)
    if (bool == true) then
        return false;
    else
        return true;
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createText(frame,label,size,x,y)
    local cfs = frame:CreateFontString(nil, 'ARTWORK');
    cfs:SetPoint("TOPLEFT", x, y);
    cfs:SetFont(getAddonDefaultFont(), size,"OUTLINE");
    cfs:SetShadowOffset(1, -1);
    cfs:SetTextColor(1, 1, 1);
    cfs:SetNonSpaceWrap(false);
    cfs:SetText(label);
    return cfs;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createCheckbox(name,frameContainer,label,checked,x,y,clickHandler)
	local checkbox = CreateFrame("CheckButton", name, frameContainer);
	checkbox:SetWidth(20);
	checkbox:SetHeight(23);
	checkbox:SetPoint("TOPLEFT", x, y);
	
	checkbox:SetHitRectInsets(0, -200, 0, 0);
	checkbox:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
	checkbox:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
	checkbox:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight");
	checkbox:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
	
	local description = checkbox:CreateFontString(name.."Label", "ARTWORK", "GameFontHighlight");
	description:SetPoint("LEFT", checkbox, "RIGHT", 1, 1);
	description:SetText(label);
	description:SetTextColor(1,1,1);
	description:SetFont(getAddonDefaultFont(), DCVGlobal["DCUIFontSize"],"OUTLINE");
	description:SetJustifyH("LEFT");
    local txtW = description:GetStringWidth();
    checkbox:SetHitRectInsets(0, -txtW, 0, 0);
	
	-- Defaults
	checkbox:SetChecked(checked);
	
	checkbox:SetScript("OnClick", function(frame)
		clickHandler(frame:GetChecked());
		checked = frame:GetChecked();
		local tick = frame:GetChecked();
		if tick then
			playClick();
		else
			playClick();
		end
	end)	
	
	return checkbox;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

--function createSlider(frame,id,x,y,min,max,default,label,width,callBackFunction,decimals)
function createSlider(name,frameContainer,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler)
    x = x +5;

	local slider = CreateFrame("Slider", name, frameContainer, "OptionsSliderTemplate");
	slider:ClearAllPoints();
	slider:SetPoint("TOPLEFT", x, y-20);
	slider:SetMinMaxValues(min,max);
	slider:SetValue(default);
    slider:SetOrientation('HORIZONTAL')
    slider:SetWidth(width);
    slider:SetHeight(18);
    slider:SetObeyStepOnDrag(true);
	slider:SetValueStep(step);
    
	--log(slider:GetName());
	
	getglobal(name .. 'Low'):SetText(min);
	getglobal(name .. 'High'):SetText(max);
    
	local txt = getglobal(slider:GetName() .. 'Text');
    if (label ~= "") then
		txt:SetText( label .. " " .. string.format("%."..decimalPrecision.."f",default) );
    else   
		txt:SetText( string.format("%."..decimalPrecision.."f",default) );
    end
    
    getglobal(slider:GetName() .. 'Low'):SetFont(getAddonDefaultFont(),12,"OUTLINE")
    getglobal(slider:GetName() .. 'High'):SetFont(getAddonDefaultFont(),12,"OUTLINE")
    getglobal(slider:GetName() .. 'Text'):SetFont(getAddonDefaultFont(),12,"OUTLINE")
    
	slider:Show();
	slider:SetScript("OnValueChanged", function(self, value)
        if (label ~= "") then
			txt:SetText( label .. " " .. string.format("%."..decimalPrecision.."f",value) );
		else   
			txt:SetText( string.format("%."..decimalPrecision.."f",value) );
		end
        changeHandler(value);
	end)
    	
	return slider;
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- -- http://wowprogramming.com/snippets/Create_UI-styled_dropdown_menu_10
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createDropDown(name,frameContainer,width,labels,default,x,y,clickHandlerFunction)
	--log("name["..name.."] default = " .. default);
	local dropDown = CreateFrame("Button", name, frameContainer, "UIDropDownMenuTemplate");
	dropDown:ClearAllPoints();
	dropDown:SetPoint("TOPLEFT", x-16, y);
	dropDown:Show();
	
	function dropDown:SetSelected(index)
		UIDropDownMenu_SetSelectedID(self, index);
	end
	
	local function OnClick(self)
		--log("Selected index = " .. self:GetID());
		UIDropDownMenu_SetSelectedID(dropDown, self:GetID());
		--print(self:GetID());
		clickHandlerFunction(self:GetID());
	end
	
	local function initialize(self, level)
		local info = UIDropDownMenu_CreateInfo();
		for k,v in pairs(labels) do
			info = UIDropDownMenu_CreateInfo();
			info.text = v;
			info.value = v;
			info.func = OnClick;
			UIDropDownMenu_AddButton(info, level);
		end
	end
	
	UIDropDownMenu_Initialize(dropDown, initialize);
	UIDropDownMenu_SetWidth(dropDown, width-10);
	UIDropDownMenu_SetButtonWidth(dropDown, width+6); -- hit area is smaller
	UIDropDownMenu_SetSelectedID(dropDown, default);
	UIDropDownMenu_JustifyText(dropDown, "LEFT");
	
	return dropDown;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createButton(name,frameContainer,label,width,x,y,clickHandler)
	local btn = CreateFrame("button",name, frameContainer, "UIPanelButtonTemplate")
	btn:SetHeight(22)
	btn:SetWidth(width)
	btn:SetPoint("TOPLEFT", frameContainer, "TOPLEFT", x, y)
	btn:SetText(label)
	btn:SetScript("OnClick", clickHandler)
	return btn;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function createLabel(name,frameContainer,text,size,r,g,b,a,justify,x,y)
	local txt = frameContainer:CreateFontString(name, "OVERLAY");
	txt:SetFont(getAddonDefaultFont(),size,"OUTLINE");
	txt:SetTextColor(r,g,b,a);
	txt:SetPoint("TOPLEFT", frameContainer, "TOPLEFT", x, y);
	txt:SetText(text);
	txt:SetJustifyH(justify);
	return txt;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #